searchNodes=[{"doc":"Mojito is an easy-to-use, high-performance HTTP client built using the low-level Mint library . Mojito is built for comfort and for speed. Behind a simple and predictable interface, there is a sophisticated connection pool manager that delivers maximum throughput with no intervention from the user. Just want to make one request and bail? No problem. Mojito can make one-off requests as well, using the same process-less architecture as Mint. Quickstart { :ok , response } = Mojito . request ( method : :get , url : &quot;https://github.com&quot; ) Why Mojito? Mojito addresses the following design goals: Little or no configuration needed. Use Mojito to make requests to as many different destinations as you like, without thinking about starting or selecting connection pools. Other clients like Hackney (and HTTPoison ), Ibrowse (and HTTPotion ), and Erlang's built-in httpc offer this feature, except that... Connection pools should be used only for a single destination. Using a pool for making requests against multiple destinations is less than ideal, as many of the connections need to be reset before use. Mojito assigns requests to the correct pools transparently to the user. Other clients, such as Buoy , Hackney/ HTTPoison, Ibrowse/HTTPotion, etc. force the user to handle this themselves, which is often inconvenient if the full set of HTTP destinations is not known at compile time. Redundant pools to reduce concurrency-related bottlenecks. Mojito can serve requests to the same destination from more than one connection pool, and those pools can be selected by round-robin at runtime in order to minimize resource contention in the Erlang VM. This feature is unique to Mojito. Installation Add mojito to your deps in mix.exs : { :mojito , &quot;~&gt; 0.7.7&quot; } Upgrading from 0.4 and earlier Upgrading to 0.7 cannot be performed safely inside a hot upgrade. Deploy a regular release instead. Upgrading from 0.4 to 0.5 requires no end-user code changes. Mojito 0.5 refactors some internal functions in a way that changes their arity and order of arguments. Using request methods other than those in the Mojito module is deprecated since 0.3. A handful of new config parameters appeared in 0.3 as well. Configuration The following config.exs config parameters are supported: :timeout ( :infinity or milliseconds, default 5000 ) -- Default request timeout. :transport_opts ( t:Keyword.t , default [] ) -- Options to pass to the :gen_tcp or :ssl modules. Commonly used to make HTTPS requests with self-signed TLS server certificates; see below for details. :pool_opts ( t:pool_opts , default [] ) -- Configuration options for connection pools. The following :pool_opts options are supported: :size (integer) sets the number of steady-state connections per pool. Default is 5. :max_overflow (integer) sets the number of additional connections per pool, opened under conditions of heavy load. Default is 10. :pools (integer) sets the maximum number of pools to open for a single destination host and port (not the maximum number of total pools to open). Default is 5. :strategy is either :lifo or :fifo , and selects which connection should be checked out of a single pool. Default is :lifo . :destinations (keyword list of t:pool_opts ) allows these parameters to be set for individual :&quot;host:port&quot; destinations. For example: use Mix.Config config :mojito , timeout : 2500 , pool_opts : [ size : 10 , destinations : [ &quot;example.com:443&quot; : [ size : 20 , max_overflow : 20 , pools : 10 ] ] ] Certain configs can be overridden with each request. See request/1 . Usage Make requests with Mojito.request/1 or Mojito.request/5 : &gt;&gt;&gt; &gt; Mojito . request ( :get , &quot;https://jsonplaceholder.typicode.com/posts/1&quot; ) ## or... &gt;&gt;&gt; &gt; Mojito . request ( %{ method : :get , url : &quot;https://jsonplaceholder.typicode.com/posts/1&quot; } ) ## or... &gt;&gt;&gt; &gt; Mojito . request ( method : :get , url : &quot;https://jsonplaceholder.typicode.com/posts/1&quot; ) { :ok , % Mojito.Response { body : &quot;{ \\n \\&quot; userId \\&quot; : 1, \\n \\&quot; id \\&quot; : 1, \\n \\&quot; title \\&quot; : \\&quot; sunt aut facere repellat provident occaecati excepturi optio reprehenderit \\&quot; , \\n \\&quot; body \\&quot; : \\&quot; quia et suscipit \\\\ nsuscipit recusandae consequuntur expedita et cum \\\\ nreprehenderit molestiae ut ut quas totam \\\\ nnostrum rerum est autem sunt rem eveniet architecto \\&quot; \\n }&quot; , headers : [ { &quot;content-type&quot; , &quot;application/json; charset=utf-8&quot; } , { &quot;content-length&quot; , &quot;292&quot; } , { &quot;connection&quot; , &quot;keep-alive&quot; } , ... ] , status_code : 200 } } In addition to Mojito.request/5 , Mojito also provides convenience functions like Mojito.head/3 , Mojito.get/3 , Mojito.post/4 , Mojito.put/4 , Mojito.patch/4 , Mojito.delete/3 , and Mojito.options/3 for each corresponding HTTP methods. By default, Mojito will use a connection pool for requests, automatically handling the creation and reuse of pools. If this is not desired, specify the pool: false option with a request to perform a one-off request. See the documentation for request/1 for more details. Self-signed SSL/TLS certificates To accept self-signed certificates in HTTPS connections, you can give the transport_opts: [verify: :verify_none] option to Mojito.request or Mojito.Pool.request : Examples &gt;&gt;&gt; &gt; Mojito . request ( method : :get , url : &quot;https://localhost:8443/&quot; ) { :error , { :tls_alert , &#39;bad certificate&#39; } } &gt;&gt;&gt; &gt; Mojito . request ( method : :get , url : &quot;https://localhost:8443/&quot; , opts : [ transport_opts : [ verify : :verify_none ] ] ) { :ok , % Mojito.Response { ... } } Telemetry Mojito integrates with the standard Telemetry library. See the Mojito.Telemetry module for more information. Changelog See the CHANGELOG.md . Contributing Thanks for considering contributing to this project, and to the free software ecosystem at large! Interested in contributing a bug report? Terrific! Please open a GitHub issue and include as much detail as you can. If you have a solution, even better -- please open a pull request with a clear description and tests. Have a feature idea? Excellent! Please open a GitHub issue for discussion. Want to implement an issue that's been discussed? Fantastic! Please open a GitHub pull request and write a clear description of the patch. We'll merge your PR a lot sooner if it is well-documented and fully tested. Contributors and contributions are listed in the changelog . Heartfelt thanks to everyone who's helped make Mojito better. Authorship and License Copyright 2018-2019, Appcues, Inc. This software is released under the MIT License.","ref":"Mojito.html","title":"Mojito","type":"module"},{"doc":"Performs an HTTP DELETE request and returns the response. See request/1 for documentation and examples.","ref":"Mojito.html#delete/3","title":"Mojito.delete/3","type":"function"},{"doc":"Performs an HTTP GET request and returns the response. Examples Assemble a URL with a query string params and fetch it with GET request: &gt;&gt;&gt; &gt; &quot;https://www.google.com/search&quot; ...&gt; |&gt; URI . parse ( ) ...&gt; |&gt; Map . put ( :query , URI . encode_query ( %{ &quot;q&quot; =&gt; &quot;mojito elixir&quot; } ) ) ...&gt; |&gt; URI . to_string ( ) ...&gt; |&gt; Mojito . get ( ) { :ok , % Mojito.Response { body : &quot;&lt;!doctype html&gt;&lt;html lang= \\&quot; en \\&quot; &gt;&lt;head&gt;&lt;meta charset= \\&quot; UTF-8 \\&quot; &gt; ...&quot; , complete : true , headers : [ { &quot;content-type&quot; , &quot;text/html; charset=ISO-8859-1&quot; } , ... ] , status_code : 200 } } See request/1 for detailed documentation.","ref":"Mojito.html#get/3","title":"Mojito.get/3","type":"function"},{"doc":"Performs an HTTP HEAD request and returns the response. See request/1 for documentation.","ref":"Mojito.html#head/3","title":"Mojito.head/3","type":"function"},{"doc":"Performs an HTTP OPTIONS request and returns the response. See request/1 for documentation.","ref":"Mojito.html#options/3","title":"Mojito.options/3","type":"function"},{"doc":"Performs an HTTP PATCH request and returns the response. See request/1 and post/4 for documentation and examples.","ref":"Mojito.html#patch/4","title":"Mojito.patch/4","type":"function"},{"doc":"Performs an HTTP POST request and returns the response. Examples Submitting a form with POST request: &gt;&gt;&gt; &gt; Mojito . post ( ...&gt; &quot;http://localhost:4000/messages&quot; , ...&gt; [ { &quot;content-type&quot; , &quot;application/x-www-form-urlencoded&quot; } ] , ...&gt; URI . encode_query ( %{ &quot;message[subject]&quot; =&gt; &quot;Contact request&quot; , &quot;message[content]&quot; =&gt; &quot;data&quot; } ) ) { :ok , % Mojito.Response { body : &quot;Thank you!&quot; , complete : true , headers : [ { &quot;server&quot; , &quot;Cowboy&quot; } , { &quot;connection&quot; , &quot;keep-alive&quot; } , ... ] , status_code : 200 } } Submitting a JSON payload as POST request body: &gt;&gt;&gt; &gt; Mojito . post ( ...&gt; &quot;http://localhost:4000/api/messages&quot; , ...&gt; [ { &quot;content-type&quot; , &quot;application/json&quot; } ] , ...&gt; Jason . encode! ( %{ &quot;message&quot; =&gt; %{ &quot;subject&quot; =&gt; &quot;Contact request&quot; , &quot;content&quot; =&gt; &quot;data&quot; } } ) ) { :ok , % Mojito.Response { body : &quot;{ \\&quot; message \\&quot; : \\&quot; Thank you! \\&quot; }&quot; , complete : true , headers : [ { &quot;server&quot; , &quot;Cowboy&quot; } , { &quot;connection&quot; , &quot;keep-alive&quot; } , ... ] , status_code : 200 } } See request/1 for detailed documentation.","ref":"Mojito.html#post/4","title":"Mojito.post/4","type":"function"},{"doc":"Performs an HTTP PUT request and returns the response. See request/1 and post/4 for documentation and examples.","ref":"Mojito.html#put/4","title":"Mojito.put/4","type":"function"},{"doc":"Performs an HTTP request and returns the response. If the pool: true option is given, or :pool is not specified, the request will be made using Mojito's automatic connection pooling system. For more details, see Mojito.Pool.request/1 . This is the default mode of operation, and is recommended for best performance. If pool: false is given as an option, the request will be made on a brand new connection. This does not spawn an additional process. Messages of the form {:tcp, _, _} or {:ssl, _, _} will be sent to and handled by the caller. If the caller process expects to receive other :tcp or :ssl messages at the same time, conflicts can occur; in this case, it is recommended to wrap request/1 in Task.async/1 , or use one of the pooled request modes. Options: :pool - See above. :timeout - Response timeout in milliseconds, or :infinity . Defaults to Application.get_env(:mojito, :timeout, 5000) . :raw - Set this to true to prevent the decompression of gzip or compress -encoded responses. :transport_opts - Options to be passed to either :gen_tcp or :ssl . Most commonly used to perform insecure HTTPS requests via transport_opts: [verify: :verify_none] .","ref":"Mojito.html#request/1","title":"Mojito.request/1","type":"function"},{"doc":"Performs an HTTP request and returns the response. See request/1 for details.","ref":"Mojito.html#request/5","title":"Mojito.request/5","type":"function"},{"doc":"","ref":"Mojito.html#t:body/0","title":"Mojito.body/0","type":"type"},{"doc":"","ref":"Mojito.html#t:error/0","title":"Mojito.error/0","type":"type"},{"doc":"","ref":"Mojito.html#t:header/0","title":"Mojito.header/0","type":"type"},{"doc":"","ref":"Mojito.html#t:headers/0","title":"Mojito.headers/0","type":"type"},{"doc":"","ref":"Mojito.html#t:method/0","title":"Mojito.method/0","type":"type"},{"doc":"","ref":"Mojito.html#t:payload/0","title":"Mojito.payload/0","type":"type"},{"doc":"","ref":"Mojito.html#t:pool_opt/0","title":"Mojito.pool_opt/0","type":"type"},{"doc":"","ref":"Mojito.html#t:pool_opts/0","title":"Mojito.pool_opts/0","type":"type"},{"doc":"","ref":"Mojito.html#t:request/0","title":"Mojito.request/0","type":"type"},{"doc":"","ref":"Mojito.html#t:request_fields/0","title":"Mojito.request_fields/0","type":"type"},{"doc":"","ref":"Mojito.html#t:request_kwlist/0","title":"Mojito.request_kwlist/0","type":"type"},{"doc":"","ref":"Mojito.html#t:response/0","title":"Mojito.response/0","type":"type"},{"doc":"","ref":"Mojito.html#t:url/0","title":"Mojito.url/0","type":"type"},{"doc":"Provides a default implementation for Mojito functions. This module is meant to be use 'd in custom modules in order to wrap the functionalities provided by Mojiti. For example, this is very useful to build custom API clients around Mojito: defmodule CustomAPI do use Mojito.Base end","ref":"Mojito.Base.html","title":"Mojito.Base","type":"behaviour"},{"doc":"","ref":"Mojito.Base.html#c:delete/1","title":"Mojito.Base.delete/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:delete/2","title":"Mojito.Base.delete/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:delete/3","title":"Mojito.Base.delete/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:get/1","title":"Mojito.Base.get/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:get/2","title":"Mojito.Base.get/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:get/3","title":"Mojito.Base.get/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:head/1","title":"Mojito.Base.head/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:head/2","title":"Mojito.Base.head/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:head/3","title":"Mojito.Base.head/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:options/1","title":"Mojito.Base.options/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:options/2","title":"Mojito.Base.options/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:options/3","title":"Mojito.Base.options/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:patch/1","title":"Mojito.Base.patch/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:patch/2","title":"Mojito.Base.patch/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:patch/3","title":"Mojito.Base.patch/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:patch/4","title":"Mojito.Base.patch/4","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:post/1","title":"Mojito.Base.post/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:post/2","title":"Mojito.Base.post/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:post/3","title":"Mojito.Base.post/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:post/4","title":"Mojito.Base.post/4","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:put/1","title":"Mojito.Base.put/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:put/2","title":"Mojito.Base.put/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:put/3","title":"Mojito.Base.put/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:put/4","title":"Mojito.Base.put/4","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:request/1","title":"Mojito.Base.request/1","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:request/2","title":"Mojito.Base.request/2","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:request/3","title":"Mojito.Base.request/3","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:request/4","title":"Mojito.Base.request/4","type":"callback"},{"doc":"","ref":"Mojito.Base.html#c:request/5","title":"Mojito.Base.request/5","type":"callback"},{"doc":"","ref":"Mojito.Base.html#t:body/0","title":"Mojito.Base.body/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:error/0","title":"Mojito.Base.error/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:header/0","title":"Mojito.Base.header/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:headers/0","title":"Mojito.Base.headers/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:method/0","title":"Mojito.Base.method/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:payload/0","title":"Mojito.Base.payload/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:pool_opt/0","title":"Mojito.Base.pool_opt/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:pool_opts/0","title":"Mojito.Base.pool_opts/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:request/0","title":"Mojito.Base.request/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:request_field/0","title":"Mojito.Base.request_field/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:request_kwlist/0","title":"Mojito.Base.request_kwlist/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:response/0","title":"Mojito.Base.response/0","type":"type"},{"doc":"","ref":"Mojito.Base.html#t:url/0","title":"Mojito.Base.url/0","type":"type"},{"doc":"Functions for working with HTTP request and response headers, as described in the HTTP 1.1 specification . Headers are represented in Elixir as a list of {&quot;header_name&quot;, &quot;value&quot;} tuples. Multiple entries for the same header name are allowed. Capitalization of header names is preserved during insertion, however header names are handled case-insensitively during lookup and deletion.","ref":"Mojito.Headers.html","title":"Mojito.Headers","type":"module"},{"doc":"Returns an HTTP Basic Auth header from the given username and password. Example: iex&gt; Mojito.Headers . auth_header ( &quot;hello&quot; , &quot;world&quot; ) { &quot;authorization&quot; , &quot;Basic aGVsbG86d29ybGQ=&quot; }","ref":"Mojito.Headers.html#auth_header/2","title":"Mojito.Headers.auth_header/2","type":"function"},{"doc":"Convert non string values to string where is possible. Example: iex&gt; Mojito.Headers . convert_values_to_string ( [ { &quot;content-length&quot; , 0 } ] ) [ { &quot;content-length&quot; , &quot;0&quot; } ]","ref":"Mojito.Headers.html#convert_values_to_string/1","title":"Mojito.Headers.convert_values_to_string/1","type":"function"},{"doc":"Removes all instances of the given header. Header names are matched case-insensitively. Example: iex&gt; headers = [ ...&gt; { &quot;header1&quot; , &quot;foo&quot; } , ...&gt; { &quot;header2&quot; , &quot;bar&quot; } , ...&gt; { &quot;Header1&quot; , &quot;baz&quot; } ...&gt; ] iex&gt; Mojito.Headers . delete ( headers , &quot;HEADER1&quot; ) [ { &quot;header2&quot; , &quot;bar&quot; } ]","ref":"Mojito.Headers.html#delete/2","title":"Mojito.Headers.delete/2","type":"function"},{"doc":"Returns the value for the given HTTP request or response header, or nil if not found. Header names are matched case-insensitively. If more than one matching header is found, the values are joined with &quot;,&quot; as specified in RFC 2616 . Example: iex&gt; headers = [ ...&gt; { &quot;header1&quot; , &quot;foo&quot; } , ...&gt; { &quot;header2&quot; , &quot;bar&quot; } , ...&gt; { &quot;Header1&quot; , &quot;baz&quot; } ...&gt; ] iex&gt; Mojito.Headers . get ( headers , &quot;header2&quot; ) &quot;bar&quot; iex&gt; Mojito.Headers . get ( headers , &quot;HEADER1&quot; ) &quot;foo,baz&quot; iex&gt; Mojito.Headers . get ( headers , &quot;header3&quot; ) nil","ref":"Mojito.Headers.html#get/2","title":"Mojito.Headers.get/2","type":"function"},{"doc":"Returns all values for the given HTTP request or response header. Returns an empty list if none found. Header names are matched case-insensitively. Example: iex&gt; headers = [ ...&gt; { &quot;header1&quot; , &quot;foo&quot; } , ...&gt; { &quot;header2&quot; , &quot;bar&quot; } , ...&gt; { &quot;Header1&quot; , &quot;baz&quot; } ...&gt; ] iex&gt; Mojito.Headers . get_values ( headers , &quot;header2&quot; ) [ &quot;bar&quot; ] iex&gt; Mojito.Headers . get_values ( headers , &quot;HEADER1&quot; ) [ &quot;foo&quot; , &quot;baz&quot; ] iex&gt; Mojito.Headers . get_values ( headers , &quot;header3&quot; ) [ ]","ref":"Mojito.Headers.html#get_values/2","title":"Mojito.Headers.get_values/2","type":"function"},{"doc":"Returns an ordered list of the header names from the given headers. Header names are returned in lowercase. Example: iex&gt; headers = [ ...&gt; { &quot;header1&quot; , &quot;foo&quot; } , ...&gt; { &quot;header2&quot; , &quot;bar&quot; } , ...&gt; { &quot;Header1&quot; , &quot;baz&quot; } ...&gt; ] iex&gt; Mojito.Headers . keys ( headers ) [ &quot;header1&quot; , &quot;header2&quot; ]","ref":"Mojito.Headers.html#keys/1","title":"Mojito.Headers.keys/1","type":"function"},{"doc":"Returns a copy of the given headers where all header names are lowercased and multiple values for the same header have been joined with &quot;,&quot; . Example: iex&gt; headers = [ ...&gt; { &quot;header1&quot; , &quot;foo&quot; } , ...&gt; { &quot;header2&quot; , &quot;bar&quot; } , ...&gt; { &quot;Header1&quot; , &quot;baz&quot; } ...&gt; ] iex&gt; Mojito.Headers . normalize ( headers ) [ { &quot;header1&quot; , &quot;foo,baz&quot; } , { &quot;header2&quot; , &quot;bar&quot; } ]","ref":"Mojito.Headers.html#normalize/1","title":"Mojito.Headers.normalize/1","type":"function"},{"doc":"Puts the given header value under name , removing any values previously stored under name . The new header is placed at the end of the list. Header names are matched case-insensitively, but case of name is preserved when adding the header. Example: iex&gt; headers = [ ...&gt; { &quot;header1&quot; , &quot;foo&quot; } , ...&gt; { &quot;header2&quot; , &quot;bar&quot; } , ...&gt; { &quot;Header1&quot; , &quot;baz&quot; } ...&gt; ] iex&gt; Mojito.Headers . put ( headers , &quot;HEADER1&quot; , &quot;quux&quot; ) [ { &quot;header2&quot; , &quot;bar&quot; } , { &quot;HEADER1&quot; , &quot;quux&quot; } ]","ref":"Mojito.Headers.html#put/3","title":"Mojito.Headers.put/3","type":"function"},{"doc":"","ref":"Mojito.Headers.html#t:headers/0","title":"Mojito.Headers.headers/0","type":"type"},{"doc":"Mojito's Telemetry integration. All time measurements are emitted in :millisecond units by default. A different Erlang time unit can be chosen by setting a config parameter like so: config :mojito , Mojito.Telemetry , time_unit : :microsecond Mojito emits the following Telemetry events: [:mojito, :pool, :start] before launching a pool Measurements: :system_time Metadata: :host , :port [:mojito, :pool, :stop] after launching a pool Measurements: :system_time , :duration Metadata: :host , :port [:mojito, :connect, :start] before connecting to a host Measurements: :system_time Metadata: :host , :port [:mojito, :connect, :stop] after connecting to a host Measurements: :system_time , :duration Metadata: :host , :port [:mojito, :request, :start] before making a request Measurements: :system_time Metadata: :host , :port , :path , :method [:mojito, :request, :stop] after making a request Measurements: :system_time , :duration Metadata: :host , :port , :path , :method","ref":"Mojito.Telemetry.html","title":"Mojito.Telemetry","type":"module"}]